VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4290
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5520
   LinkTopic       =   "Form1"
   ScaleHeight     =   4290
   ScaleWidth      =   5520
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   315
      Left            =   2160
      TabIndex        =   13
      Top             =   2400
      Width           =   1815
   End
   Begin VB.TextBox txtPhone 
      Height          =   315
      Left            =   1080
      TabIndex        =   12
      Top             =   3840
      Width           =   4335
   End
   Begin VB.TextBox txtName_Last 
      Height          =   315
      Left            =   1080
      TabIndex        =   11
      Top             =   3480
      Width           =   4335
   End
   Begin VB.TextBox txtName_First 
      Height          =   315
      Left            =   1080
      TabIndex        =   10
      Top             =   3120
      Width           =   4335
   End
   Begin VB.TextBox txtUsername 
      Height          =   315
      Left            =   1080
      TabIndex        =   9
      Top             =   2760
      Width           =   4335
   End
   Begin VB.TextBox txtClient_Id 
      Enabled         =   0   'False
      Height          =   315
      Left            =   1080
      TabIndex        =   8
      Top             =   2400
      Width           =   975
   End
   Begin MSComctlLib.ListView lvClients 
      Height          =   1815
      Left            =   0
      TabIndex        =   2
      Top             =   480
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   3201
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.TextBox txtSearch 
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Text            =   "Search for Client"
      Top             =   120
      Width           =   4095
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Height          =   315
      Left            =   4200
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "phone"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   3840
      Width           =   855
   End
   Begin VB.Label Label3 
      Caption         =   "name_last"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   3480
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "name_first"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   3120
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "username"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   2760
      Width           =   855
   End
   Begin VB.Label lblClientID 
      Caption         =   "client_id"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   2400
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This is an example of searching/updating a database from VB6
'Search example is in cmdSearch_click and the update example is in cmdUpdate_click

'For this example you need to do the following
'Add reference: Microsoft ActiveX Data Objects x.x Library (use latest version installed)
'Add component: Microsoft Windows Common Controls 6 sp6
'Add command buttons: cmdSearch, cmdUpdate

'Add textboxes: ...
'txtSearch
'txtClient_id
'txtUsername
'txtName_First
'txtName_Last
'txtPhone

'Make new access database called MyDB.mdb in path of saved project
'Make table in database called clients
'Make fields in table called:...
'client_id      autonumber
'username       text
'name_first     text
'name_last      text
'phone          text

'Add some mock client info to the database manually in access

Option Explicit
'Set path to DB
'Note project must be saved or compiled for app.path to work
'This assumes db is in same folder as project/exe
Dim strMyDB As String
Const DefaultSearchText = "Search For Client"

Private Sub Form_Load()
    strMyDB = App.Path & "\" & "MyDB.mdb"
    txtSearch.Text = DefaultSearchText
End Sub

Private Sub cmdSearch_Click()
    'Search for a client
    
    Dim cn As New ADODB.Connection
    Dim rs As New ADODB.Recordset
    Dim strSQL As String
    Dim arWords, iWord As Long
    Dim xItem As ListItem
    Dim curField As field
    Dim i As Integer
    lvClients.ListItems.Clear
    lvClients.ColumnHeaders.Clear
    
    'Open DB connection
    'for other DB connection strings go to http://www.thescripts.com/forum/thread572278.html
    cn.Open "Provider=Microsoft.Jet.OLEDB.4.0;" & _
               "Data Source=" & strMyDB & ";"
    
    'Put the words searched for into an array and fix any apostrophies
    arWords = Split(FixApostrophies(txtSearch.Text), " ")
    
    'Start query
    strSQL = "SELECT * FROM clients WHERE"
    
    'Build filter requiring all words entered
    '   to be in username, name_first, or name_last field
    For iWord = 0 To UBound(arWords)
        If iWord > 0 Then strSQL = strSQL & " AND"
        strSQL = strSQL & " ("
        strSQL = strSQL & "username like '%" & arWords(iWord) & "%'"
        strSQL = strSQL & " OR"
        strSQL = strSQL & " name_first like '%" & arWords(iWord) & "%'"
        strSQL = strSQL & " OR"
        strSQL = strSQL & " name_last like '%" & arWords(iWord) & "%'"
        strSQL = strSQL & ")"
    Next 'iWord
    
    'Query the database
    rs.Open strSQL, cn
    
    'Create column headers for listview based on field names
    If Not rs.EOF Then
        For Each curField In rs.Fields
            lvClients.ColumnHeaders.Add , , curField.Name
        Next 'curField
    End If

    'Populate listview with recordset
    While Not rs.EOF
        'Debug.Print rs("username") & vbTab & rs("phone")
        Set xItem = lvClients.ListItems.Add(, , rs.Fields(0).Value)
        For i = 1 To (rs.Fields.Count - 1)
            xItem.ListSubItems.Add , , rs.Fields(i).Value
        Next
        'Move to next record in recordset
        rs.MoveNext
    Wend
    
    'close recordset/connection
    rs.Close
    cn.Close
    'remove references
    Set rs = Nothing
    Set cn = Nothing
End Sub

Private Sub cmdUpdate_Click()
    'Update client's record
    Dim cn As New ADODB.Connection
    Dim rs As New ADODB.Recordset
    Dim strSQL As String
    
    'Open DB connection
    cn.Open "Provider=Microsoft.Jet.OLEDB.4.0;" & _
               "Data Source=" & strMyDB & ";"
    
    'create SQL statement to select client from a unique record id
    strSQL = "SELECT * FROM clients" & _
        " WHERE client_id=" & FixApostrophies(txtClient_Id.Text)
    
    rs.Open strSQL, cn, adOpenForwardOnly, adLockOptimistic
    
    'See if there's a record found
    If rs.EOF Then
        'record not found
        MsgBox "That record no longer exists"
    Else
        'record found, update record
        rs("username") = txtUsername.Text
        rs("name_last") = txtName_Last.Text
        rs("name_first") = txtName_First.Text
        rs("phone") = txtPhone.Text
        'update the recordset
        rs.Update
    End If
    'close recordset/connection
    rs.Close
    cn.Close
    'remove references
    Set rs = Nothing
    Set cn = Nothing
End Sub

Private Sub lvClients_ItemClick(ByVal Item As MSComctlLib.ListItem)
    Dim header As ColumnHeader
    Dim ret
    
    'Loop through column headers, and populate textboxes with same name (but have 'txt' prefix)
    For Each header In lvClients.ColumnHeaders
        On Error Resume Next
        ret = Me.Controls("txt" & header.Text)
        If Err.Number <> 0 Then
            MsgBox Err.Description
            Err.Clear
            On Error GoTo 0
            GoTo NextHeader:
        End If
        
        If header.Index > 1 Then
            Me.Controls("txt" & header.Text).Text = Item.ListSubItems(header.Index - 1).Text
        Else
            Me.Controls("txt" & header.Text).Text = Item.Text
        End If
NextHeader:
    Next 'header
End Sub

Function FixApostrophies(ByVal sInput As String) As String
    'Use for text that will be included as part of a query
    If InStr(1, sInput, "'") Then
        'Fix apostrophies
        FixApostrophies = Replace(sInput, "'", "''")
    Else
        FixApostrophies = sInput
    End If
End Function

Function RandomInt(ByVal HighVal As Long, Optional ByVal LowVal As Long = 0) As Long
    Randomize
    RandomInt = CLng((HighVal * Rnd) + LowVal)
End Function

Private Sub txtClient_Id_Change()
    cmdUpdate.Enabled = True
End Sub

'########### Everthing below is unnecessary code ##########
Private Sub txtSearch_GotFocus()
    cmdSearch.Default = True
    If txtSearch.Text <> "" And txtSearch.Text = DefaultSearchText Then
        txtSearch.Text = Empty
    Else
        txtSearch.SelStart = 0
        txtSearch.SelLength = Len(txtSearch.Text)
    End If
End Sub


Private Sub txtSearch_LostFocus()
    cmdSearch.Default = False
    If txtSearch.Text = "" Then txtSearch.Text = DefaultSearchText
End Sub

